Skip to main content
Docs

JavaScript Quickstart

To add the JavaScript SDK to your JavaScript app, you have two options:

  1. Install the package using a package manager, like npm.
  2. Use the <script> tag to load the ClerkJS package from our CDN.

Use the following tabs to choose your preferred method.

Create a new JavaScript app

To install Clerk's JavaScript SDK, you need to use a bundler like Vite or Webpack.

If you don't already have a JavaScript app, run the following commands to create a new one using Vite. From the prompts, choose the Vanilla framework, and then choose the JavaScript variant.

npm create vite@latest clerk-javascript
cd clerk-javascript
npm install
pnpm create vite clerk-javascript
cd clerk-javascript
pnpm install
yarn create vite clerk-javascript
cd clerk-javascript
yarn install
bunx create-vite clerk-javascript
cd clerk-javascript
bun install

Install @clerk/clerk-js

The Clerk JavaScript SDK gives you access to a set of classes and methods to make user authentication easier.

Run the following command to install the SDK:

npm install @clerk/clerk-js
pnpm add @clerk/clerk-js
yarn add @clerk/clerk-js
bun add @clerk/clerk-js

Set your Clerk API keys

It's recommended to use environment variables to store your Clerk . In JavaScript projects, you can store these values in an .env file and load them using your framework's env variable support. In Node.js, you can load .env files by starting your app with the --env-file=.env flag. For Vite projects, environment variables in an .env file at the project root are automatically accessible through the import.meta.env object.

.env
VITE_CLERK_PUBLISHABLE_KEY=YOUR_PUBLISHABLE_KEY

Initialize Clerk

To initialize Clerk, add the following code to your main.js file. This code does the following:

  • Imports your and derives the Clerk domain from it.
  • Dynamically loads the UI bundle.
  • Creates a new Clerk instance.
  • Calls the load() method to initialize Clerk.
src/main.js
import { Clerk } from '@clerk/clerk-js'

const publishableKey = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY

if (!publishableKey) {
  throw new Error('Add your VITE_CLERK_PUBLISHABLE_KEY to the .env file')
}

// Derive the Frontend API domain from the publishable key
const clerkDomain = atob(publishableKey.split('_')[2]).slice(0, -1)

// Loads the Clerk UI bundle
await new Promise((resolve, reject) => {
  const script = document.createElement('script')
  script.src = `https://${clerkDomain}/npm/@clerk/ui@1/dist/ui.browser.js`
  script.async = true
  script.crossOrigin = 'anonymous'
  script.onload = resolve
  script.onerror = () => reject(new Error('Failed to load @clerk/ui bundle'))
  document.head.appendChild(script)
})

const clerk = new Clerk(publishableKey)
await clerk.load({
  ui: { ClerkUI: window.__internal_ClerkUICtor },
})

Add Clerk components to your app

Clerk's prebuilt components are the easiest way to add authentication and user management to your app. They come styled out-of-the-box and are customizable to fit your app's design.

To get started, add the following components to your app:

  • <SignIn />: Renders a user interface for signing in.
  • <UserButton />: Shows the signed-in user's avatar. Selecting it opens a dropdown menu with account management options.

Your main.js file should look something like this:

src/main.js
import { Clerk } from '@clerk/clerk-js'

const publishableKey = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY

if (!publishableKey) {
  throw new Error('Add your VITE_CLERK_PUBLISHABLE_KEY to the .env file')
}

// Derive the Frontend API domain from the publishable key
const clerkDomain = atob(publishableKey.split('_')[2]).slice(0, -1)

// Loads the Clerk UI bundle
await new Promise((resolve, reject) => {
  const script = document.createElement('script')
  script.src = `https://${clerkDomain}/npm/@clerk/ui@1/dist/ui.browser.js`
  script.async = true
  script.crossOrigin = 'anonymous'
  script.onload = resolve
  script.onerror = () => reject(new Error('Failed to load @clerk/ui bundle'))
  document.head.appendChild(script)
})

const clerk = new Clerk(publishableKey)
await clerk.load({
  ui: { ClerkUI: window.__internal_ClerkUICtor },
})

if (clerk.isSignedIn) {
  document.getElementById('app').innerHTML = `
    <div id="user-button"></div>
  `
  const userButtonDiv = document.getElementById('user-button')
  clerk.mountUserButton(userButtonDiv)
} else {
  document.getElementById('app').innerHTML = `
    <div id="sign-in"></div>
  `
  const signInDiv = document.getElementById('sign-in')
  clerk.mountSignIn(signInDiv)
}

And your index.html file should look something like this:

index.html
<!doctype html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <link rel="icon" type="image/svg+xml" href="/vite.svg" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Vite App</title>
  </head>
  <body>
    <div id="app"></div>
    <script type="module" src="/src/main.js"></script>
  </body>
</html>

Run your project

Run your project with the following command:

npm run dev
pnpm run dev
yarn dev
bun run dev

Create your first user

  1. Visit your app's homepage at http://localhost:5173.
  2. Select "Sign up" on the page and authenticate to create your first user.

Add the SDK using a <script> tag

These <script> tags will load Clerk's UI bundle and JavaScript SDK from the CDN and initialize them with your Clerk and . They should be placed before any other <script> tags that use the JavaScript SDK.

  1. In the Clerk Dashboard, navigate to the API keys page.
  2. In the Quick Copy section, select JavaScript from the dropdown menu.
  3. Copy the <script> tags and paste them into your HTML file, as shown in the following example:
index.html
<!-- Rest of your HTML file -->

<script
  defer
  crossorigin="anonymous"
  src="https://YOUR_FRONTEND_API_URL/npm/@clerk/ui@1/dist/ui.browser.js"
  type="text/javascript"
></script>

<script
  defer
  crossorigin="anonymous"
  data-clerk-publishable-key="YOUR_PUBLISHABLE_KEY"
  src="https://YOUR_FRONTEND_API_URL/npm/@clerk/clerk-js@6/dist/clerk.browser.js"
  type="text/javascript"
></script>

Listen for the load event

Below the <script> tags that initialize the SDK, create another <script> tag that listens for the load event and calls Clerk's load() method to load the SDK, as shown in the following example:

index.html
<!-- Rest of your HTML file -->

<script>
  window.addEventListener('load', async function () {
    await Clerk.load({
      ui: { ClerkUI: window.__internal_ClerkUICtor },
    })

    console.log('ClerkJS is loaded')
  })
</script>

Allow users to sign in or out

Clerk's prebuilt components are the easiest way to add authentication and user management to your app. They come styled out-of-the-box and are customizable to fit your app's design.

To get started, you will use:

  • <SignIn />: renders a user interface for signing in.
  • <UserButton />: Shows the signed-in user's avatar. Selecting it opens a dropdown menu with account management options.
index.html
<div id="app"></div>

<script
  defer
  crossorigin="anonymous"
  src="https://YOUR_FRONTEND_API_URL/npm/@clerk/ui@1/dist/ui.browser.js"
  type="text/javascript"
></script>

<script
  defer
  crossorigin="anonymous"
  data-clerk-publishable-key="YOUR_PUBLISHABLE_KEY"
  src="https://YOUR_FRONTEND_API_URL/npm/@clerk/clerk-js@6/dist/clerk.browser.js"
  type="text/javascript"
></script>

<script>
  window.addEventListener('load', async function () {
    await Clerk.load({
      ui: { ClerkUI: window.__internal_ClerkUICtor },
    })

    if (Clerk.isSignedIn) {
      document.getElementById('app').innerHTML = `
        <div id="user-button"></div>
      `

      const userButtonDiv = document.getElementById('user-button')

      Clerk.mountUserButton(userButtonDiv)
    } else {
      document.getElementById('app').innerHTML = `
        <div id="sign-in"></div>
      `

      const signInDiv = document.getElementById('sign-in')

      Clerk.mountSignIn(signInDiv)
    }
  })
</script>

Next steps

Learn more about Clerk components, custom sign-in and sign-up flows (including MFA), and how to use Clerk's JavaScript classes using the following guides.

Prebuilt components

Learn how to quickly add authentication to your app using Clerk's suite of components.

Create a custom sign-up and sign-in flow

Learn how to build a custom sign-up and sign-in authentication flow.

Create a custom sign-in flow with MFA

Learn how to build a custom sign-in flow with multi-factor authentication.

Clerk class reference

Learn more about the Clerk class and how to use it.

Feedback

What did you think of this content?

Last updated on

Skip to main content
Docs

Vue Quickstart

This tutorial assumes that you're using Vue 3 with TypeScript.

Create a new Vue app

If you don't already have a Vue app, run the following commands to create a new one using Vite:

npm create vite@latest clerk-vue -- --template vue-ts
cd clerk-vue
npm install
pnpm create vite clerk-vue --template vue-ts
cd clerk-vue
pnpm install
yarn create vite clerk-vue --template vue-ts
cd clerk-vue
yarn install
bunx create-vite clerk-vue --template vue-ts
cd clerk-vue
bun install

Install @clerk/vue

The Clerk Vue SDKVue.js Icon gives you access to prebuilt components, composables, and helpers to make user authentication easier.

Run the following command to install the SDK:

npm install @clerk/vue
pnpm add @clerk/vue
yarn add @clerk/vue
bun add @clerk/vue
.env
VITE_CLERK_PUBLISHABLE_KEY=YOUR_PUBLISHABLE_KEY

Add clerkPlugin to your app

clerkPluginVue.js Icon provides session and user context to Clerk's components and composables. It's required to pass your Clerk as an option. You can add an if statement to check that the key is imported properly. This prevents the app from running without the Publishable Key and catches TypeScript errors.

The clerkPlugin accepts optional options, such as { signInForceRedirectUrl: '/dashboard' }.

src/main.ts
import { createApp } from 'vue'
import './style.css'
import App from './App.vue'
import { clerkPlugin } from '@clerk/vue'

const PUBLISHABLE_KEY = import.meta.env.VITE_CLERK_PUBLISHABLE_KEY

if (!PUBLISHABLE_KEY) {
  throw new Error('Add your Clerk Publishable Key to the .env file')
}

const app = createApp(App)
app.use(clerkPlugin, { publishableKey: PUBLISHABLE_KEY })
app.mount('#app')

Create a header with Clerk components

You can control which content signed-in and signed-out users can see with Clerk's prebuilt control components. The following example creates a header using the following components:

src/App.vue
<script setup lang="ts">
import { Show, SignInButton, SignUpButton, UserButton } from '@clerk/vue'
</script>

<template>
  <header>
    <Show when="signed-out">
      <SignInButton />
      <SignUpButton />
    </Show>
    <Show when="signed-in">
      <UserButton />
    </Show>
  </header>
</template>

Run your project

Run your project with the following command:

npm run dev
pnpm run dev
yarn dev
bun run dev

Create your first user

  1. Visit your app's homepage at http://localhost:5173.
  2. Select "Sign up" on the page and authenticate to create your first user.

Next steps

Learn more about Clerk components, how to customize them, and how to use Clerk's client-side helpers using the following guides.

Prebuilt components

Learn how to quickly add authentication to your app using Clerk's suite of components.

Customization & localization

Learn how to customize and localize Clerk components.

Client-side helpers (composables)

Learn more about Clerk's client-side helpers and how to use them.

Update Clerk options at runtime

Learn how to update Clerk's options at runtime in your Vue app.

Feedback

What did you think of this content?

Last updated on

Skip to main content
Docs

React Quickstart

Use this pre-built prompt to get started faster.

This tutorial will demonstrate how to create a new React app using Vite and add authentication to it using Clerk. If you would like to create an application using the React Router framework, see the React Router quickstartReact Router Icon.

Create a new React app

If you don't already have a React app, run the following commands to create a new one using Vite.

npm create vite@latest clerk-react -- --template react-ts
cd clerk-react
npm install
pnpm create vite clerk-react --template react-ts
cd clerk-react
pnpm install
yarn create vite clerk-react --template react-ts
cd clerk-react
yarn install
bunx create-vite clerk-react --template react-ts
cd clerk-react
bun install

Install @clerk/react

The Clerk React SDKReact Icon gives you access to prebuilt components, hooks, and helpers to make user authentication easier.

Run the following command to install the SDK:

npm install @clerk/react
pnpm add @clerk/react
yarn add @clerk/react
bun add @clerk/react
.env
VITE_CLERK_PUBLISHABLE_KEY=YOUR_PUBLISHABLE_KEY

Add <ClerkProvider> to your app

The <ClerkProvider> component provides session and user context to Clerk's hooks and components. It's recommended to wrap your entire app at the entry point with <ClerkProvider> to make authentication globally accessible. See the reference docs for other configuration options.

src/main.tsx
import { StrictMode } from 'react'
import { createRoot } from 'react-dom/client'
import './index.css'
import App from './App.tsx'
import { ClerkProvider } from '@clerk/react'

createRoot(document.getElementById('root')!).render(
  <StrictMode>
    <ClerkProvider>
      <App />
    </ClerkProvider>
  </StrictMode>,
)

Create a header with Clerk components

You can control which content signed-in and signed-out users can see with the prebuilt control components. The following example creates a header using the following components:

src/App.tsx
import './App.css'
import { Show, SignInButton, SignUpButton, UserButton } from '@clerk/react'

function App() {
  return (
    <>
      <header>
        <Show when="signed-out">
          <SignInButton />
          <SignUpButton />
        </Show>
        <Show when="signed-in">
          <UserButton />
        </Show>
      </header>
    </>
  )
}

export default App

Run your project

Run your project with the following command:

npm run dev
pnpm run dev
yarn dev
bun run dev

Create your first user

  1. Visit your app's homepage at http://localhost:5173.
  2. Select "Sign up" on the page and authenticate to create your first user.

Next steps

Learn more about Clerk components, routing, and how to use Clerk's React hooks using the following guides.

Prebuilt components

Learn how to quickly add authentication to your app using Clerk's suite of components.

Protect content and read user data

Learn how to use Clerk's hooks to protect content and read user data in your React app.

Add routing

Learn how to add React Router in declarative mode to your React app.

Get started with Organizations

Learn how to create and manage Organizations in your React app.

Feedback

What did you think of this content?

Last updated on